/*----------------------------------------------------------------------------
 *      RL-ARM - RTX
 *----------------------------------------------------------------------------
 *      Name:    Ex2_RTX_events.C
 *      Purpose: RTX example program
 *----------------------------------------------------------------------------
 *      This code is part of the RealView Run-Time Library.
 *      Copyright (c) 2012 KEIL - An ARM Company. All rights reserved.
 *---------------------------------------------------------------------------*/

#include "cmsis_os.h"
#include "stm32f0xx.h"
#include "stm32f0_discovery.h"
#include "LED.h"



/*----------------------------------------------------------------------------
  User Variables
 *---------------------------------------------------------------------------*/
int	LED_0_toggle_counter = 0;		/* used to count number of toggles for LED 0 */
int	LED_1_toggle_counter = 0;		/* used to count number of toggles for LED 1 */


/*----------------------------------------------------------------------------
  Thread IDs
 *---------------------------------------------------------------------------*/	

osThreadId T_led_1;


/*----------------------------------------------------------------------------
  Forward Reference
 *---------------------------------------------------------------------------*/	

void led_1 (void const *argument);


/*----------------------------------------------------------------------------
  Thread Definitions
 *---------------------------------------------------------------------------*/	

osThreadDef(led_1, osPriorityNormal, 1, 0);








/*----------------------------------------------------------------------------
  Thread 1 'led_0': Toggle LED 0
 *---------------------------------------------------------------------------*/


																				/* Turn LED 0 On                     */
																				/* Delay running task for 500 ticks	 */
																				/* Turn LED 0 On                     */
																				/* Delay running task for 500 ticks	 */
																				/* Increment LED 0 toggle counter		 */
		


/*----------------------------------------------------------------------------
  Thread 2 'led_1': Toggle LED 1
 *---------------------------------------------------------------------------*/
void led_1 (void const *argument) {
  for (;;) {
    LED_On(1);                          /* Turn LED On                       */
    osDelay(250);												/* Delay running task for 250 ticks	 */
		LED_Off(1);													/* Turn LED 0 On                     */
		osDelay(250);												/* Delay running task for 250 ticks	 */
		LED_1_toggle_counter++;							/* Increment LED 1 toggle counter		 */
		}
}




/*----------------------------------------------------------------------------
  Main: Initialize and start RTX Kernel
 *---------------------------------------------------------------------------*/
int main (void) {
	
	/* Initialise various hardware elements used in project */
	SystemInit();  				// CMSIS SystemInit clocks and PLLs
	
	LED_Init ();					// Initialise LED's on F0 discovery kit
	
	
	/* Create the threads for the RTOS to run */
	T_led_1 					= osThreadCreate(osThread(led_1), NULL);
	
  
	
												// Pass runtime to next READY task	
}









